﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _917803_RadGanttViewAllowNulls
{
    public partial class Form1 : Form
    {
        private DataSet copiedData;

        public Form1()
        {
            InitializeComponent();

            this.radGanttView1.GanttViewElement.GraphicalViewElement.TimelineStart = new DateTime(2010, 10, 05);
            this.radGanttView1.GanttViewElement.GraphicalViewElement.TimelineEnd = new DateTime(2010, 10, 20);
            this.radGanttView1.TextViewCellFormatting += radGanttView1_TextViewCellFormatting;

            DataTable tasks = new DataTable("Tasks");
            tasks.Columns.Add("Id", typeof(int));
            tasks.Columns.Add("ParentId", typeof(int));
            tasks.Columns.Add("Title", typeof(string));
            tasks.Columns.Add("Start", typeof(DateTime));
            tasks.Columns.Add("End", typeof(DateTime));
            tasks.Columns.Add("Progress", typeof(decimal));

            DataTable links = new DataTable("Links");
            links.Columns.Add("StartId", typeof(int));
            links.Columns.Add("EndId", typeof(int));
            links.Columns.Add("LinkType", typeof(int));

            DataSet data = new DataSet();
            data.Tables.Add(tasks);
            data.Tables.Add(links);

            this.copiedData = data;
            this.ValidateTasks();

            tasks.Rows.Add(1, 0, "Summary task title", new DateTime(2010, 10, 10), new DateTime(2010, 10, 15), 30m);
            tasks.Rows.Add(2, 1, "First child task title", new DateTime(2010, 10, 10), new DateTime(2010, 10, 12), 10);
            tasks.Rows.Add(3, 1, "Second child task title", new DateTime(2010, 10, 12), new DateTime(2010, 10, 15), 20m);
            tasks.Rows.Add(4, 1, "Milestone", new DateTime(2010, 10, 15), new DateTime(2010, 10, 15), 0m);
            tasks.Rows.Add(4, 0, "Null Item ", null, null, 0m);
            this.ValidateTasks();

            links.Rows.Add(2, 3, 1);
            links.Rows.Add(3, 4, 1);

            this.radGanttView1.GanttViewElement.TaskDataMember = "Tasks";
            this.radGanttView1.GanttViewElement.ChildMember = "Id";
            this.radGanttView1.GanttViewElement.ParentMember = "ParentId";
            this.radGanttView1.GanttViewElement.TitleMember = "Title";
            this.radGanttView1.GanttViewElement.StartMember = "Start";
            this.radGanttView1.GanttViewElement.EndMember = "End";
            this.radGanttView1.GanttViewElement.ProgressMember = "Progress";
            this.radGanttView1.GanttViewElement.LinkDataMember = "Links";
            this.radGanttView1.GanttViewElement.LinkStartMember = "StartId";
            this.radGanttView1.GanttViewElement.LinkEndMember = "EndId";
            this.radGanttView1.GanttViewElement.LinkTypeMember = "LinkType";

            this.radGanttView1.GanttViewElement.DataSource = copiedData;

            this.radGanttView1.Columns.Add("Title");
            this.radGanttView1.Columns.Add("Start");
            this.radGanttView1.Columns.Add("End");
        }

        private void ValidateTasks()
        {
            foreach (DataRow row in this.copiedData.Tables[0].Rows)
            {
                for (int i = 0; i < this.copiedData.Tables[0].Columns.Count; i++)
                {
                    object value = row[i];
                    if (value == DBNull.Value)
                    {
                        row[i] = DateTime.MinValue;
                    }
                }
            }
        }

        private void radGanttView1_TextViewCellFormatting(object sender, Telerik.WinControls.UI.GanttViewTextViewCellFormattingEventArgs e)
        {
            if (e.Item != null && e.Item.Start < this.radGanttView1.GanttViewElement.GraphicalViewElement.TimelineStart)
            {
                if (e.CellElement.Column.Name == "Start" || e.CellElement.Column.Name == "End")
                {
                    e.CellElement.Text = "";
                }
            }
        }
    }
}
